.586
OPTION CASEMAP:NONE
.CODE
;--------------------------------------------------------------------------------
TreeView_Init			PROC	uses edi
	
	mov		edi,		pGPMemory
	INVOKE	SHGetDesktopFolder,	ADDR ShF_Desktop
	INVOKE	SHGetMalloc,		ADDR p_IMalloc
	
	mov		(TV_INSERTSTRUCT ptr [edi]).hParent,TVI_ROOT
	mov		(TV_INSERTSTRUCT ptr [edi]).hInsertAfter,TVI_FIRST	
	mov		(TV_INSERTSTRUCT ptr [edi]).item.imask,TVIF_CHILDREN or TVIF_PARAM or TVIF_TEXT 
	mov		(TV_INSERTSTRUCT ptr [edi]).item.hItem ,NULL
	mov		(TV_INSERTSTRUCT ptr [edi]).item.state,NULL
	mov		(TV_INSERTSTRUCT ptr [edi]).item.stateMask,NULL
	mov		(TV_INSERTSTRUCT ptr [edi]).item.pszText,OFFSET strDesktop
	mov		(TV_INSERTSTRUCT ptr [edi]).item.cchTextMax,NULL
	mov		(TV_INSERTSTRUCT ptr [edi]).item.iImage,NULL
	mov		(TV_INSERTSTRUCT ptr [edi]).item.iSelectedImage ,NULL
	mov		(TV_INSERTSTRUCT ptr [edi]).item.cChildren ,1
	mov		eax,			ShF_Desktop
	mov		(TV_INSERTSTRUCT ptr [edi]).item.lParam,eax
	INVOKE	SendMessage,	hWnd_M_Tree,TVM_INSERTITEM,0,edi
	mov		hItm_Desktop,	eax
	
	INVOKE	TreeView_Expand_Item,hItm_Desktop
	
	INVOKE	SendMessage,	hWnd_M_Tree,TVM_EXPAND,TVE_EXPAND,hItm_Desktop
ret
TreeView_Init 		ENDP
;--------------------------------------------------------------------------------
TreeView_Kill			PROC	uses edi

	INVOKE	TreeView_Collapse_Item,ShF_Desktop
	COMVOKE	p_IMalloc.Release
	COMVOKE	ShF_Desktop.Release
	
ret
TreeView_Kill		ENDP
;--------------------------------------------------------------------------------
TreeView_Expand_Item	PROC	uses edi	hItem:DWORD
LOCAL	pEnumItems			:DWORD
LOCAL	IShellFolder_Crt	:DWORD
LOCAL	IShellFolder_Enum	:DWORD
LOCAL	InsertedItem		:TV_INSERTSTRUCT
LOCAL	RetValNext			:DWORD
LOCAL	STRRET_Return		:STRRET
LOCAL	Attributes			:DWORD
mov		edi,		pGPMemory
	
	mov		eax,				hItem
	mov		(TV_ITEM ptr [edi]).imask,TVIF_HANDLE or TVIF_PARAM
	mov		(TV_ITEM ptr [edi]).hItem,eax
	mov		(TV_ITEM ptr [edi]).state,NULL
	mov		(TV_ITEM ptr [edi]).stateMask,NULL
	mov		(TV_ITEM ptr [edi]).pszText,NULL
	mov		(TV_ITEM ptr [edi]).cchTextMax,NULL
	mov		(TV_ITEM ptr [edi]).iImage,NULL
	mov		(TV_ITEM ptr [edi]).iSelectedImage,NULL
	mov		(TV_ITEM ptr [edi]).cChildren,NULL
	mov		(TV_ITEM ptr [edi]).lParam,NULL
	INVOKE	SendMessage,	hWnd_M_Tree,TVM_GETITEM,0,edi
	or		eax,			eax
	jz		Get_Out
	mov		ecx,			(TV_ITEM ptr [edi]).lParam
	mov		IShellFolder_Crt,ecx
	or		ecx,			ecx
	jz		Get_Out
	
	COMVOKE	IShellFolder_Crt.IShellFolder.EnumObjects,NULL,SHCONTF_FOLDERS,ADDR pEnumItems
	or		eax,			eax
	jnz		Get_Out
	COMVOKE	pEnumItems.IEnumIDList.Reset
	
	mov		eax,		hItem
	mov		InsertedItem.hInsertAfter,TVI_LAST	
	mov		InsertedItem.item.imask,TVIF_CHILDREN or TVIF_PARAM or TVIF_TEXT 
	mov		InsertedItem.item.hItem ,NULL
	mov		InsertedItem.item.state,NULL
	mov		InsertedItem.hParent,eax
	mov		InsertedItem.item.pszText,edi
	mov		InsertedItem.item.stateMask,NULL
	mov		InsertedItem.item.cchTextMax,NULL
	mov		InsertedItem.item.iImage,NULL
	mov		InsertedItem.item.iSelectedImage ,NULL
	mov		InsertedItem.item.cChildren ,1
	
	EnumLoop_Entry:
		COMVOKE	pEnumItems.IEnumIDList.Next,1,ADDR RetValNext,NULL
		or		eax,			eax
		jnz		EnumLoop_Exit
		COMVOKE IShellFolder_Crt.IShellFolder.GetDisplayNameOf,RetValNext,SHGDN_NORMAL,ADDR STRRET_Return
		or		eax,			eax
		jnz		EnumLoop_Exit
		
		lea		eax,		STRRET_Return
		mov		eax,		dword ptr [eax+4]
		xor		ecx,		ecx
		.WHILE	ecx<255
			mov		dl,		byte ptr [eax+ecx*2]
			mov		byte ptr [edi+ecx],dl
			.BREAK .IF	dl==0
			inc		ecx
		.ENDW
		mov		Attributes,		SFGAO_CONTENTSMASK
		COMVOKE	IShellFolder_Crt.IShellFolder.GetAttributesOf,1,ADDR RetValNext,ADDR Attributes
		and		Attributes,		SFGAO_HASSUBFOLDER
		.IF		Attributes==0
			mov		InsertedItem.item.cChildren ,0
		.ELSE
			mov		InsertedItem.item.cChildren ,1
		.ENDIF
		
		COMVOKE IShellFolder_Crt.IShellFolder.BindToObject,RetValNext,NULL,ADDR IID_IShellFolder,ADDR IShellFolder_Enum
		or		eax,			eax
		jnz		EnumLoop_Exit
		mov		ecx,			IShellFolder_Enum
		mov		InsertedItem.item.lParam,ecx
		INVOKE	SendMessage,	hWnd_M_Tree,TVM_INSERTITEM,0,ADDR InsertedItem 
		or		eax,			eax
		jz		EnumLoop_Exit
		COMVOKE	p_IMalloc.Free,		RetValNext
		or		eax,				eax
		jz		EnumLoop_Entry
		jmp		EnumLoop_Entry
	EnumLoop_Exit:
	
	COMVOKE	pEnumItems.IEnumIDList.Release
Get_Out:
ret
TreeView_Expand_Item	ENDP
;--------------------------------------------------------------------------------
TreeView_Collapse_Item	PROC	uses edi	hItem:DWORD
LOCAL	hLastItem	:DWORD
LOCAL	CrtHandle	:DWORD
LOCAL	TempHandle	:DWORD

	mov		edi,			pGPMemory
	mov		eax,			hItem
	mov		CrtHandle,		eax

	mov		ecx,			edi
	add		ecx,			(SIZEOF TV_ITEM)+010h
	mov		(TV_ITEM ptr [edi]).pszText,ecx
	mov		(TV_ITEM ptr [edi]).cchTextMax,GPMemory_Init_Size -((SIZEOF TV_ITEM)+010h)

	INVOKE	SendMessage,		hWnd_M_Tree,TVM_GETNEXTITEM,TVGN_NEXT,hItem
	.IF		eax==0
		mov		eax,		CrtHandle
	.ENDIF
	mov		hLastItem,			eax
	
	ScanTreeView_Entry:
		GetNextItem_Entry:
			;find first child
			INVOKE	SendMessage,	hWnd_M_Tree,TVM_GETNEXTITEM,TVGN_CHILD,CrtHandle
			or		eax,			eax
			jnz		GetNextItem_Exit
			;find next
			INVOKE	SendMessage,	hWnd_M_Tree,TVM_GETNEXTITEM,TVGN_NEXT,CrtHandle
			or		eax,			eax
			jnz		GetNextItem_Exit
			;find parent
			mov		eax,			CrtHandle
			mov		TempHandle,		eax
			
			@@:
			INVOKE	SendMessage,	hWnd_M_Tree,TVM_GETNEXTITEM,TVGN_PARENT,TempHandle
			or		eax,			eax
			jz		GetNextItem_Exit
			cmp		eax,			hLastItem
			je		GetNextItem_Exit
			mov		TempHandle,		eax
			INVOKE	SendMessage,	hWnd_M_Tree,TVM_GETNEXTITEM,TVGN_NEXT,eax
			or		eax,			eax
			jz		@B
		GetNextItem_Exit:
		or		eax,		eax
		jz		ScanTreeView_Exit
		cmp		eax,		hLastItem
		je		ScanTreeView_Exit
		mov		CrtHandle,			eax
		mov		(TV_ITEM ptr [edi]).hItem,	eax
		
		mov		(TV_ITEM ptr [edi]).state,	NULL
		mov		(TV_ITEM ptr [edi]).stateMask,NULL
		mov		(TV_ITEM ptr [edi]).iImage,	NULL
		mov		(TV_ITEM ptr [edi]).iSelectedImage ,NULL
		mov		(TV_ITEM ptr [edi]).cChildren,1
		mov		(TV_ITEM ptr [edi]).lParam,	NULL
		mov		(TV_ITEM ptr [edi]).imask,	TVIF_HANDLE or TVIF_PARAM or TVIF_TEXT 
		INVOKE	SendMessage,		hWnd_M_Tree,TVM_GETITEM,0,edi
		or		eax,				eax
		jz		ScanTreeView_Exit
		cmp		(TV_ITEM ptr [edi]).lParam,NULL
		je		@F
			;release
			mov		eax,		(TV_ITEM ptr [edi]).lParam
			push	eax
			mov		eax,		[eax]
			call	dword ptr [eax+8]
		@@:
		
		jmp		ScanTreeView_Entry
	ScanTreeView_Exit:
	
	
Get_Out:
ret
TreeView_Collapse_Item	ENDP
;--------------------------------------------------------------------------------








