.586
OPTION CASEMAP:NONE
.CODE
;--------------------------------------------------------------------------------
CreateInitWindows	PROC	uses edi
	
	mov		edi,		pGPMemory
	;fill the structure for registering
    mov   	(WNDCLASSEX ptr [edi]).cbSize,					SIZEOF WNDCLASSEX 
    mov   	(WNDCLASSEX ptr [edi]).style, 					Style_MW_Class
    mov   	(WNDCLASSEX ptr [edi]).lpfnWndProc, 			OFFSET WndProc 
    mov   	(WNDCLASSEX ptr [edi]).cbClsExtra,				NULL 
    mov   	(WNDCLASSEX ptr [edi]).cbWndExtra,				NULL 
    mov		eax,					  						hInstance 
    mov   	(WNDCLASSEX ptr [edi]).hInstance,				eax 
    mov   	(WNDCLASSEX ptr [edi]).hbrBackground,			COLOR_BACKGROUND+1 
    mov   	(WNDCLASSEX ptr [edi]).lpszMenuName,			NULL 
    mov   	(WNDCLASSEX ptr [edi]).lpszClassName,			OFFSET ClassName_MainWindow
    INVOKE 	LoadIcon,										NULL,IDI_EXCLAMATION 
    mov   	(WNDCLASSEX ptr [edi]).hIcon,					eax 
    mov   	(WNDCLASSEX ptr [edi]).hIconSm,					eax 
    INVOKE	LoadCursor,										0,IDC_ARROW
    mov   	(WNDCLASSEX ptr [edi]).hCursor,					eax
    ;and go register
    INVOKE 	RegisterClassEx, 								edi
	or		eax,			eax
	jz		Get_Out
;
;					A N O T H E R    C L A S S E S 
;
	
	;main window
    INVOKE 	CreateWindowEx,		Style_MW_Extended,\
    							ADDR ClassName_MainWindow,ADDR AppName,\ 
                				Style_MW_Std,\ 
	 						    CW_USEDEFAULT,\
	 						    CW_USEDEFAULT,\
	 						    600,\
	 						    400,\
	 						    NULL,NULL,hInstance,NULL 
    mov    	hWnd_Main,			eax
	or		eax,				eax
	jz		Get_Out
	
	;tree window
	INVOKE	GetClientRect,hWnd_Main,edi
	mov		eax,		(RECT ptr [edi]).right
	shr		eax,		1
	mov		(RECT ptr [edi]).left,eax
	sub		(RECT ptr [edi]).bottom,	30
	
	INVOKE	CreateWindowEx,WS_EX_ACCEPTFILES or WS_EX_CLIENTEDGE,\
			ADDR ClsName_TreeView,
			NULL,
			WS_VISIBLE or WS_CHILD or WS_CLIPSIBLINGS or WS_HSCROLL or WS_VSCROLL or WS_TABSTOP or \
			TVS_HASLINES or TVS_LINESATROOT or TVS_HASBUTTONS or TVS_EDITLABELS,\
			0,\
			0,\
			(RECT ptr [edi]).left,\
			(RECT ptr [edi]).bottom,\
			hWnd_Main,NULL,hInstance,NULL
	mov		hWnd_M_Tree,	eax
	or		eax,		eax
	jz		Get_Out	
	
	
	
Get_Out__OK:
mov		eax,	1
ret
Get_Out_ERR:
xor		eax,	eax
Get_Out:
ret
CreateInitWindows 	ENDP
;--------------------------------------------------------------------------------
WndProc	 					PROC	 hWnd:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM
	
	mov		eax,			hWnd
	;				MAIN WINDOW
		cmp		eax,			hWnd_Main
		jne		MainWindow_END
			;			WM_CLOSE
				cmp		uMsg,			WM_CLOSE
				jne		MW_WM_CLOSE__END
					INVOKE	TreeView_Kill
					INVOKE	DestroyWindow,	hWnd_Main
					jmp		MSG_Processed_YES
			MW_WM_CLOSE__END:
			;			WM_DESTROY
				cmp		uMsg,			WM_DESTROY
				jne		MW_WM_DESTROY__END
					INVOKE	PostQuitMessage, 	NULL
					jmp		MSG_Processed_YES
			MW_WM_DESTROY__END:
			;			WM_NOTIFY
				cmp		uMsg,			WM_NOTIFY
				jne		MW_WM_NOTIFY__END
					mov		eax,			lParam
					mov		ecx,			(NMHDR ptr [eax]).hwndFrom
					;tree view
					cmp		ecx,			hWnd_M_Tree
					jne		Not_Tree_View
						;expanding or collapsing
						cmp		(NMHDR ptr [eax]).code,TVN_ITEMEXPANDING
						jne		Not_TVW_ExCol
							mov		ecx,			(NM_TREEVIEW ptr [eax]).itemNew.hItem
							cmp		ecx,			hItm_Desktop
							je		MSG_Processed_NOT
							cmp		(NM_TREEVIEW ptr [eax]).action,TVE_COLLAPSE
							jne		@F							
								;item is collapsing
								INVOKE	TreeView_Collapse_Item,(NM_TREEVIEW ptr [eax]).itemNew.hItem
								jmp		Not_TVW_ExCol_Ready
							@@:
								;item is expanding
								INVOKE	TreeView_Expand_Item,(NM_TREEVIEW ptr [eax]).itemNew.hItem
							Not_TVW_ExCol_Ready:
							mov		eax,		FALSE
							ret
						Not_TVW_ExCol:
						;expanded or collapsed
						cmp		(NMHDR ptr [eax]).code,TVN_ITEMEXPANDED
						jne		Not_TVW_ExCol_ok
							mov		ecx,			(NM_TREEVIEW ptr [eax]).itemNew.hItem
							cmp		ecx,			hItm_Desktop
							je		MSG_Processed_NOT
							cmp		(NM_TREEVIEW ptr [eax]).action,TVE_COLLAPSE
							jne		MSG_Processed_NOT
							mov		ecx,			(NM_TREEVIEW ptr [eax]).itemNew.hItem
							mov		uMsg,			ecx
							mov		hWnd,			1
							.WHILE	hWnd!=0
								INVOKE	SendMessage,		hWnd_M_Tree,TVM_GETNEXTITEM,TVGN_CHILD,uMsg
								mov		hWnd,				eax
								.BREAK .IF eax==0
								INVOKE	SendMessage,		hWnd_M_Tree,TVM_DELETEITEM,0,hWnd
							.ENDW
							jmp		MSG_Processed_YES
						Not_TVW_ExCol_ok:
						;
						jmp		MSG_Processed_NOT
					Not_Tree_View:
					;
					
					jmp		MSG_Processed_NOT
			MW_WM_NOTIFY__END:
			
		MainWindow_END:
	;				ANOTHER WINDOW



MSG_Processed_NOT:
INVOKE 	DefWindowProc,		hWnd,uMsg,wParam,lParam     
ret
MSG_Processed_YES:
xor eax,eax
ret
WndProc						ENDP
;--------------------------------------------------------------------------------
Message_Loop				PROC
LOCAL msg:MSG 
	
    .WHILE TRUE                                                        
        INVOKE 	GetMessage, 					ADDR msg,NULL,0,0 
        .BREAK 	.IF (!eax) 
        INVOKE 	TranslateMessage, 				ADDR msg 
        INVOKE 	DispatchMessage, 				ADDR msg 
   .ENDW 
    mov     eax,							msg.wParam   	
ret
Message_Loop 				ENDP
;--------------------------------------------------------------------------------





















